#include "server/network/Server.h"
#include "gaming-core/utils/Clock.h"
#include "server/GameServer.h"

int main() {
    Server server(11196);
    if(server.hasError()) {
        return 0;
    }
    
    GameServer gameServer;
    
    Clock clock;
    constexpr Clock::Nanos NANOS_PER_TICK = 50000000;
    Clock::Nanos lag = 0;
    while(gameServer.isRunning()) {
        lag += clock.update();
        while(lag >= NANOS_PER_TICK) {
            lag -= NANOS_PER_TICK;
            server.consumeEvents(gameServer);
            gameServer.tick();
        }
        Clock::Nanos waitNanos = NANOS_PER_TICK - lag;
        if(waitNanos > 300000) {
            clock.wait(waitNanos);
        }
    }
    return 0;
}